unofficial mirror of notmuch@notmuchmail.org
 help / color / mirror / code / Atom feed
From: David Bremner <david@tethera.net>
To: notmuch@notmuchmail.org
Subject: [PATCH 2/6] test: add known broken test for notmuch_tags_valid (NULL)
Date: Wed, 25 May 2022 07:51:13 -0300	[thread overview]
Message-ID: <20220525105117.10709-3-david@tethera.net> (raw)
In-Reply-To: <20220525105117.10709-1-david@tethera.net>

This should return false, but currently segfaults.

Start a new file for tags library API related tests. This is maybe
overkill, but new C boilerplate which doesn't corrupt the database is
needed anyway.
---
 test/T560-lib-error.sh | 18 ---------
 test/T565-lib-tags.sh  | 86 ++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 86 insertions(+), 18 deletions(-)
 create mode 100755 test/T565-lib-tags.sh

diff --git a/test/T560-lib-error.sh b/test/T560-lib-error.sh
index 1f4482cb..a6d89346 100755
--- a/test/T560-lib-error.sh
+++ b/test/T560-lib-error.sh
@@ -245,24 +245,6 @@ EOF
 test_expect_equal_file EXPECTED OUTPUT.clean
 restore_database
 
-backup_database
-test_begin_subtest "Xapian exception getting tags"
-cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR} ${POSTLIST_PATH}
-   {
-       notmuch_tags_t *tags = NULL;
-       tags = notmuch_database_get_all_tags (db);
-       stat = (tags == NULL);
-   }
-EOF
-sed 's/^\(A Xapian exception [^:]*\):.*$/\1/' < OUTPUT > OUTPUT.clean
-cat <<'EOF' >EXPECTED
-== stdout ==
-== stderr ==
-A Xapian exception occurred getting tags
-EOF
-test_expect_equal_file EXPECTED OUTPUT.clean
-restore_database
-
 backup_database
 test_begin_subtest "Xapian exception creating directory"
 cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR} ${POSTLIST_PATH}
diff --git a/test/T565-lib-tags.sh b/test/T565-lib-tags.sh
new file mode 100755
index 00000000..0f3595d2
--- /dev/null
+++ b/test/T565-lib-tags.sh
@@ -0,0 +1,86 @@
+#!/usr/bin/env bash
+test_description="API tests for tags"
+
+. $(dirname "$0")/test-lib.sh || exit 1
+
+add_email_corpus
+
+test_begin_subtest "building database"
+test_expect_success "NOTMUCH_NEW"
+
+cat <<EOF > c_head
+#include <stdio.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <fcntl.h>
+#include <talloc.h>
+#include <notmuch.h>
+
+int main (int argc, char** argv)
+{
+   notmuch_database_t *db;
+   notmuch_status_t stat;
+   char *path;
+   char *msg = NULL;
+   int fd;
+
+   stat = notmuch_database_open_with_config (argv[1],
+					      NOTMUCH_DATABASE_MODE_READ_WRITE,
+					      NULL, NULL, &db, &msg);
+   if (stat != NOTMUCH_STATUS_SUCCESS) {
+     fprintf (stderr, "error opening database\n%s\n%s\n", notmuch_status_to_string (stat), msg ? msg : "");
+     exit (1);
+   }
+EOF
+cat <<'EOF' > c_tail
+   if (stat) {
+       const char *stat_str = notmuch_database_status_string (db);
+       if (stat_str)
+	   fputs (stat_str, stderr);
+    }
+
+}
+EOF
+
+POSTLIST_PATH=(${MAIL_DIR}/.notmuch/xapian/postlist.*)
+
+backup_database
+test_begin_subtest "Xapian exception getting tags"
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR} ${POSTLIST_PATH}
+   {
+      notmuch_tags_t *tags = NULL;
+      fd = open(argv[2],O_WRONLY|O_TRUNC);
+      if (fd < 0) {
+	  fprintf (stderr, "error opening %s\n", argv[1]);
+	  exit (1);
+       }
+       tags = notmuch_database_get_all_tags (db);
+       stat = (tags == NULL);
+   }
+EOF
+sed 's/^\(A Xapian exception [^:]*\):.*$/\1/' < OUTPUT > OUTPUT.clean
+cat <<'EOF' >EXPECTED
+== stdout ==
+== stderr ==
+A Xapian exception occurred getting tags
+EOF
+test_expect_equal_file EXPECTED OUTPUT.clean
+restore_database
+
+test_begin_subtest "NULL tags are not valid"
+test_subtest_known_broken
+cat c_head - c_tail <<'EOF' | test_C ${MAIL_DIR}
+   {
+       notmuch_bool_t valid = TRUE;
+       valid = notmuch_tags_valid (NULL);
+       fprintf(stdout, "valid = %d\n", valid);
+   }
+EOF
+cat <<'EOF' >EXPECTED
+== stdout ==
+valid = 0
+== stderr ==
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_done
-- 
2.35.2

  parent reply	other threads:[~2022-05-25 10:51 UTC|newest]

Thread overview: 8+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2022-05-25 10:51 notmuch_message* error handling cleanup part II David Bremner
2022-05-25 10:51 ` [PATCH 1/6] test: error handling for n_m_tags_to_maildir_flags David Bremner
2022-05-25 10:51 ` David Bremner [this message]
2022-05-25 10:51 ` [PATCH 3/6] lib/tag: handle NULL argument to notmuch_tags_valid David Bremner
2022-05-25 10:51 ` [PATCH 4/6] lib: Add missing private status values David Bremner
2022-05-25 10:51 ` [PATCH 5/6] lib: add NOTMUCH_STATUS_CLOSED_DATABASE, use in _n_d_ensure_writable David Bremner
2022-05-25 10:51 ` [PATCH 6/6] lib: check for writable db in n_m_tags_maildir_flags David Bremner
2022-06-25 19:38 ` notmuch_message* error handling cleanup part II David Bremner

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: https://notmuchmail.org/

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20220525105117.10709-3-david@tethera.net \
    --to=david@tethera.net \
    --cc=notmuch@notmuchmail.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://yhetil.org/notmuch.git/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).